//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private POCTrader[] cachePOCTrader = null;

        private static POCTrader checkPOCTrader = new POCTrader();

        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        public POCTrader POCTrader(string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            return POCTrader(Input, filename1, filename2, filename3, checkDelta1, checkDelta2, checkDelta3, lookBackBars1, lookBackBars2, lookBackBars3, pOCDistance1, pOCDistance2, pOCDistance3, signalBoxHeight1, signalBoxHeight2, signalBoxHeight3, signalBoxWidth1, signalBoxWidth2, signalBoxWidth3, signalDisplacement1, signalDisplacement2, signalDisplacement3);
        }

        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        public POCTrader POCTrader(Data.IDataSeries input, string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            if (cachePOCTrader != null)
                for (int idx = 0; idx < cachePOCTrader.Length; idx++)
                    if (cachePOCTrader[idx].Filename1 == filename1 && cachePOCTrader[idx].Filename2 == filename2 && cachePOCTrader[idx].Filename3 == filename3 && cachePOCTrader[idx].CheckDelta1 == checkDelta1 && cachePOCTrader[idx].CheckDelta2 == checkDelta2 && cachePOCTrader[idx].CheckDelta3 == checkDelta3 && cachePOCTrader[idx].LookBackBars1 == lookBackBars1 && cachePOCTrader[idx].LookBackBars2 == lookBackBars2 && cachePOCTrader[idx].LookBackBars3 == lookBackBars3 && cachePOCTrader[idx].POCDistance1 == pOCDistance1 && cachePOCTrader[idx].POCDistance2 == pOCDistance2 && cachePOCTrader[idx].POCDistance3 == pOCDistance3 && cachePOCTrader[idx].SignalBoxHeight1 == signalBoxHeight1 && cachePOCTrader[idx].SignalBoxHeight2 == signalBoxHeight2 && cachePOCTrader[idx].SignalBoxHeight3 == signalBoxHeight3 && cachePOCTrader[idx].SignalBoxWidth1 == signalBoxWidth1 && cachePOCTrader[idx].SignalBoxWidth2 == signalBoxWidth2 && cachePOCTrader[idx].SignalBoxWidth3 == signalBoxWidth3 && cachePOCTrader[idx].SignalDisplacement1 == signalDisplacement1 && cachePOCTrader[idx].SignalDisplacement2 == signalDisplacement2 && cachePOCTrader[idx].SignalDisplacement3 == signalDisplacement3 && cachePOCTrader[idx].EqualsInput(input))
                        return cachePOCTrader[idx];

            lock (checkPOCTrader)
            {
                checkPOCTrader.Filename1 = filename1;
                filename1 = checkPOCTrader.Filename1;
                checkPOCTrader.Filename2 = filename2;
                filename2 = checkPOCTrader.Filename2;
                checkPOCTrader.Filename3 = filename3;
                filename3 = checkPOCTrader.Filename3;
                checkPOCTrader.CheckDelta1 = checkDelta1;
                checkDelta1 = checkPOCTrader.CheckDelta1;
                checkPOCTrader.CheckDelta2 = checkDelta2;
                checkDelta2 = checkPOCTrader.CheckDelta2;
                checkPOCTrader.CheckDelta3 = checkDelta3;
                checkDelta3 = checkPOCTrader.CheckDelta3;
                checkPOCTrader.LookBackBars1 = lookBackBars1;
                lookBackBars1 = checkPOCTrader.LookBackBars1;
                checkPOCTrader.LookBackBars2 = lookBackBars2;
                lookBackBars2 = checkPOCTrader.LookBackBars2;
                checkPOCTrader.LookBackBars3 = lookBackBars3;
                lookBackBars3 = checkPOCTrader.LookBackBars3;
                checkPOCTrader.POCDistance1 = pOCDistance1;
                pOCDistance1 = checkPOCTrader.POCDistance1;
                checkPOCTrader.POCDistance2 = pOCDistance2;
                pOCDistance2 = checkPOCTrader.POCDistance2;
                checkPOCTrader.POCDistance3 = pOCDistance3;
                pOCDistance3 = checkPOCTrader.POCDistance3;
                checkPOCTrader.SignalBoxHeight1 = signalBoxHeight1;
                signalBoxHeight1 = checkPOCTrader.SignalBoxHeight1;
                checkPOCTrader.SignalBoxHeight2 = signalBoxHeight2;
                signalBoxHeight2 = checkPOCTrader.SignalBoxHeight2;
                checkPOCTrader.SignalBoxHeight3 = signalBoxHeight3;
                signalBoxHeight3 = checkPOCTrader.SignalBoxHeight3;
                checkPOCTrader.SignalBoxWidth1 = signalBoxWidth1;
                signalBoxWidth1 = checkPOCTrader.SignalBoxWidth1;
                checkPOCTrader.SignalBoxWidth2 = signalBoxWidth2;
                signalBoxWidth2 = checkPOCTrader.SignalBoxWidth2;
                checkPOCTrader.SignalBoxWidth3 = signalBoxWidth3;
                signalBoxWidth3 = checkPOCTrader.SignalBoxWidth3;
                checkPOCTrader.SignalDisplacement1 = signalDisplacement1;
                signalDisplacement1 = checkPOCTrader.SignalDisplacement1;
                checkPOCTrader.SignalDisplacement2 = signalDisplacement2;
                signalDisplacement2 = checkPOCTrader.SignalDisplacement2;
                checkPOCTrader.SignalDisplacement3 = signalDisplacement3;
                signalDisplacement3 = checkPOCTrader.SignalDisplacement3;

                if (cachePOCTrader != null)
                    for (int idx = 0; idx < cachePOCTrader.Length; idx++)
                        if (cachePOCTrader[idx].Filename1 == filename1 && cachePOCTrader[idx].Filename2 == filename2 && cachePOCTrader[idx].Filename3 == filename3 && cachePOCTrader[idx].CheckDelta1 == checkDelta1 && cachePOCTrader[idx].CheckDelta2 == checkDelta2 && cachePOCTrader[idx].CheckDelta3 == checkDelta3 && cachePOCTrader[idx].LookBackBars1 == lookBackBars1 && cachePOCTrader[idx].LookBackBars2 == lookBackBars2 && cachePOCTrader[idx].LookBackBars3 == lookBackBars3 && cachePOCTrader[idx].POCDistance1 == pOCDistance1 && cachePOCTrader[idx].POCDistance2 == pOCDistance2 && cachePOCTrader[idx].POCDistance3 == pOCDistance3 && cachePOCTrader[idx].SignalBoxHeight1 == signalBoxHeight1 && cachePOCTrader[idx].SignalBoxHeight2 == signalBoxHeight2 && cachePOCTrader[idx].SignalBoxHeight3 == signalBoxHeight3 && cachePOCTrader[idx].SignalBoxWidth1 == signalBoxWidth1 && cachePOCTrader[idx].SignalBoxWidth2 == signalBoxWidth2 && cachePOCTrader[idx].SignalBoxWidth3 == signalBoxWidth3 && cachePOCTrader[idx].SignalDisplacement1 == signalDisplacement1 && cachePOCTrader[idx].SignalDisplacement2 == signalDisplacement2 && cachePOCTrader[idx].SignalDisplacement3 == signalDisplacement3 && cachePOCTrader[idx].EqualsInput(input))
                            return cachePOCTrader[idx];

                POCTrader indicator = new POCTrader();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Filename1 = filename1;
                indicator.Filename2 = filename2;
                indicator.Filename3 = filename3;
                indicator.CheckDelta1 = checkDelta1;
                indicator.CheckDelta2 = checkDelta2;
                indicator.CheckDelta3 = checkDelta3;
                indicator.LookBackBars1 = lookBackBars1;
                indicator.LookBackBars2 = lookBackBars2;
                indicator.LookBackBars3 = lookBackBars3;
                indicator.POCDistance1 = pOCDistance1;
                indicator.POCDistance2 = pOCDistance2;
                indicator.POCDistance3 = pOCDistance3;
                indicator.SignalBoxHeight1 = signalBoxHeight1;
                indicator.SignalBoxHeight2 = signalBoxHeight2;
                indicator.SignalBoxHeight3 = signalBoxHeight3;
                indicator.SignalBoxWidth1 = signalBoxWidth1;
                indicator.SignalBoxWidth2 = signalBoxWidth2;
                indicator.SignalBoxWidth3 = signalBoxWidth3;
                indicator.SignalDisplacement1 = signalDisplacement1;
                indicator.SignalDisplacement2 = signalDisplacement2;
                indicator.SignalDisplacement3 = signalDisplacement3;
                Indicators.Add(indicator);
                indicator.SetUp();

                POCTrader[] tmp = new POCTrader[cachePOCTrader == null ? 1 : cachePOCTrader.Length + 1];
                if (cachePOCTrader != null)
                    cachePOCTrader.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePOCTrader = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.POCTrader POCTrader(string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            return _indicator.POCTrader(Input, filename1, filename2, filename3, checkDelta1, checkDelta2, checkDelta3, lookBackBars1, lookBackBars2, lookBackBars3, pOCDistance1, pOCDistance2, pOCDistance3, signalBoxHeight1, signalBoxHeight2, signalBoxHeight3, signalBoxWidth1, signalBoxWidth2, signalBoxWidth3, signalDisplacement1, signalDisplacement2, signalDisplacement3);
        }

        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        public Indicator.POCTrader POCTrader(Data.IDataSeries input, string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            return _indicator.POCTrader(input, filename1, filename2, filename3, checkDelta1, checkDelta2, checkDelta3, lookBackBars1, lookBackBars2, lookBackBars3, pOCDistance1, pOCDistance2, pOCDistance3, signalBoxHeight1, signalBoxHeight2, signalBoxHeight3, signalBoxWidth1, signalBoxWidth2, signalBoxWidth3, signalDisplacement1, signalDisplacement2, signalDisplacement3);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.POCTrader POCTrader(string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            return _indicator.POCTrader(Input, filename1, filename2, filename3, checkDelta1, checkDelta2, checkDelta3, lookBackBars1, lookBackBars2, lookBackBars3, pOCDistance1, pOCDistance2, pOCDistance3, signalBoxHeight1, signalBoxHeight2, signalBoxHeight3, signalBoxWidth1, signalBoxWidth2, signalBoxWidth3, signalDisplacement1, signalDisplacement2, signalDisplacement3);
        }

        /// <summary>
        /// POCTrader
        /// </summary>
        /// <returns></returns>
        public Indicator.POCTrader POCTrader(Data.IDataSeries input, string filename1, string filename2, string filename3, bool checkDelta1, bool checkDelta2, bool checkDelta3, int lookBackBars1, int lookBackBars2, int lookBackBars3, int pOCDistance1, int pOCDistance2, int pOCDistance3, int signalBoxHeight1, int signalBoxHeight2, int signalBoxHeight3, int signalBoxWidth1, int signalBoxWidth2, int signalBoxWidth3, int signalDisplacement1, int signalDisplacement2, int signalDisplacement3)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.POCTrader(input, filename1, filename2, filename3, checkDelta1, checkDelta2, checkDelta3, lookBackBars1, lookBackBars2, lookBackBars3, pOCDistance1, pOCDistance2, pOCDistance3, signalBoxHeight1, signalBoxHeight2, signalBoxHeight3, signalBoxWidth1, signalBoxWidth2, signalBoxWidth3, signalDisplacement1, signalDisplacement2, signalDisplacement3);
        }
    }
}
#endregion
